#include "qtguiapplication2.h"
#include <QGridLayout>
#include <QGroupBox>
#include <QLabel>
#include <QListWidget>
#include <QComboBox>
#include <QPushButton>

QtGuiApplication2::QtGuiApplication2( QWidget * parent )
	: QMainWindow( parent )
{
	ui.setupUi( this );

	setWindowTitle( "Configuration" );

	CreateWidgets();
}

void QtGuiApplication2::CreateWidgets()
{
	// see the list of all available layouts in Qt
	// https://doc.qt.io/qt-5/layout.html

	// central frame layout
	QGridLayout * main = new QGridLayout();
	main->setRowStretch( 0, 0 );
	main->setRowStretch( 1, 1 );
	main->setColumnStretch( 0, 0 );
	main->setColumnStretch( 1, 1 );
	ui.centralWidget->setLayout( main );

	// menu
	{
		QListWidget * menu = new QListWidget( this );
		menu->addItems( { "Layout", "Display", "  Icons", "  Font" } );

		main->addWidget( menu, 0, 0, 2, 1, Qt::AlignLeft );
	}

	// title
	{ 
		QLabel * lblTitle = new QLabel( "Color", this );		
		main->addWidget( lblTitle, 0, 1);
		
		lblTitle->setFrameStyle( QFrame::Panel | QFrame::Sunken );
		lblTitle->setAlignment( Qt::AlignCenter );
		lblTitle->setMinimumHeight( 25 );
		
		QPalette palette = lblTitle->palette();
		palette.setColor( lblTitle->backgroundRole(), QColor( "#99B4D1" ) );
		lblTitle->setPalette( palette );		
		lblTitle->setAutoFillBackground( true );

		//lblTitle->setStyleSheet( "QLabel { background-color : #99B4D1; color : black; }" );
	}

	// color settings frame
	{
		// create frame (container)
		QGroupBox * color = new QGroupBox( this );
		color->setTitle( "Color" );		
		// and put it inside the main layout		
		main->addWidget( color, 1, 1, Qt::AlignTop);

		// create all the widgets you need here
		// see the list of all basic widgets in Qt
		// https://doc.qt.io/qt-5/widget-classes.html#basic-widget-classes

		QLabel * lbl1 = new QLabel( this );
		lbl1->setText( "Dark mode:" );

		QComboBox * cmbModes = new QComboBox( this );
		cmbModes->addItems( QStringList( { "Always disabled", "Always enabled" } ) );		

		// create and set the current frame layout
		QGridLayout * layout = new QGridLayout( this );		
		color->setLayout( layout );

		layout->addWidget( lbl1, 0, 0, Qt::AlignLeft );
		layout->addWidget( cmbModes, 0, 1);
	}

	// buttons
	{
		QFrame * buttons = new QFrame( this );
		main->addWidget( buttons, 2, 1, Qt::AlignTop | Qt::AlignRight );

		QPushButton * btn1 = new QPushButton( "OK", this );
		btn1->setFixedWidth( 80 );

		QPushButton * btn2 = new QPushButton( "Cancel", this );
		btn2->setFixedWidth( 80 );


		QHBoxLayout * layout = new QHBoxLayout( this );
		buttons->setLayout( layout );

		layout->addWidget( btn1 );
		layout->addWidget( btn2 );
	}
}
